// ConstPropertyPtr.h

#ifndef ConstPropertyPtr_h
#define ConstPropertyPtr_h

#ifndef ConstProperty_h
#include "ConstProperty.h"
#endif

template < class Value >
class ConstPropertyPtr
  {
	private:
		ConstProperty<Value> ref;
		
	public:
		ConstPropertyPtr()
		  {}
		
		explicit ConstPropertyPtr( const ConstProperty<Value>& r )
		  : ref( r )
		  {}
		
		ConstPropertyPtr( const ConstPropertyPtr& p )
		  : ref( p.ref )
		  {}
		
		ConstPropertyPtr& operator=( const ConstPropertyPtr& r )
		  {
			ref.Reseat( r.ref );
			return *this;
		  }
		
		const ConstProperty<Value>& operator*() const	{ return ref; }
		const ConstProperty<Value> *operator->() const	{ return &ref; }
  };

#endif
