// Create.h

#ifndef Create_h
#define Create_h

#include <memory>

template < class T >
std::auto_ptr<T> Create()
  {
	return std::auto_ptr<T>( new T() );
  }

template < class T, class P0 >
std::auto_ptr<T> Create( P0 p0 )
  {
	return std::auto_ptr<T>( new T( p0 ) );
  }

template < class T, class P0, class P1 >
std::auto_ptr<T> Create( P0 p0, P1 p1 )
  {
	return std::auto_ptr<T>( new T( p0, p1 ) );
  }

template < class T, class P0, class P1, class P2 >
std::auto_ptr<T> Create( P0 p0, P1 p1, P2 p2 )
  {
	return std::auto_ptr<T>( new T( p0, p1, p2 ) );
  }

template < class T, class P0, class P1, class P2, class P3 >
std::auto_ptr<T> Create( P0 p0, P1 p1, P2 p2, P3 p3 )
  {
	return std::auto_ptr<T>( new T( p0, p1, p2, p3 ) );
  }

template < class T, class P0, class P1, class P2, class P3, class P4 >
std::auto_ptr<T> Create( P0 p0, P1 p1, P2 p2, P3 p3, P4 p4 )
  {
	return std::auto_ptr<T>( new T( p0, p1, p2, p3, p4 ) );
  }

#endif
