// Broadcaster.h

#ifndef Broadcaster_h
#define Broadcaster_h

#ifndef Observable_h
#include "Observable.h"
#endif

template < class Signature >
class Broadcaster: public Observable< Signature >
  {
	public:
		typedef ::Observable< Signature > Observable;
		typedef typename Observable::Closure Closure;
		typedef typename Observable::Observation Observation;

		using Observable::StartBroadcast;
		using Observable::BroadcastDone;
		using Observable::NextObserver;
		using Observable::ContinueBroadcast;
		using Observable::Broadcast;
  };

#endif
